//Unit Headers
#include <anchor_mover.hh>


#include <core/fragment/FragSet.hh>
#include <core/fragment/Frame.hh>
#include <core/fragment/FrameList.hh>
#include <core/kinematics/MoveMap.hh>
#include <core/types.hh>


AnchorMover::AnchorMover( core::fragment::FragSetCOP fragset,
                           protocols::abinitio::FragmentCostOP cost):
                           protocols::abinitio::ClassicFragmentMover(fragset, "AnchorMover_"+cost->type()),
                           cost_(cost) {
}

AnchorMover::AnchorMover( core::fragment::FragSetCOP fragset,
                           core::kinematics::MoveMapCOP movemap,
                           protocols::abinitio::FragmentCostOP cost):
                           protocols::abinitio::ClassicFragmentMover(fragset, "AnchorMover_"+cost->type()),
                           cost_(cost) {
}

AnchorMover::AnchorMover(core::fragment::FragSetCOP fragset, 
                          core::kinematics::MoveMapCOP movemap, 
                          protocols::abinitio::FragmentCostOP cost, 
                          std::string move_type):ClassicFragmentMover(fragset, movemap, move_type+"-"+cost->type()),
                          cost_( cost ) {
}

AnchorMover::~AnchorMover() {
}

bool AnchorMover::apply(core::pose::Pose& pose, 
                          Size pos) const {
  core::fragment::FrameList frames;
  // if(!fragset_->frames(pos, frames))
  //   return apply_frames( pose, frames );
  return false;
} 


// bool apply_frames( core::pose::Pose& pose, core::fragment::FrameList const& frames ) const {
//   core::Size frame_num;
//   core::Size frag_num;
//   bool success (false);
//   if (!choose_fragment(frames, pose, frame_num, frag_num )) 
//     return false;
//   if(!check_ss()) return apply_fragment( *frames[frame_num], frag_num, *movemap_, pose);
// 
//   std::string proposed_ss;
//   proposed_ss.reserve(pose.total_residue());
//   proposed_ss = pose.secstruct();
// 
//   std::string old_ss = proposed_ss;
//   bool valid = !valid_ss(old_ss);
//   if ( !valid ) {
//     frames[frame_num]->apply_ss(*movemap_, frag_num, proposed_ss);
//     valid = valid_ss( proposed_ss );
//   }
//   if (valid) {
//     success = apply_fragment(*frames[frame_num], frag_num, *movemap_, pose);
//   } 
//   return success;
// }

std::string AnchorMover::get_name() const {
  return "AnchorMover";
}

// bool 
// AnchorMover::choose_fragment(
//             core::fragment::FrameList const& frames, 
//             core::pose::Pose const& pose, 
//             Size &frame_num, 
//             Size& frag_num) const {
//   
//   typedef std::pair<Size, Size> FragID;
//   std::vector<FragID> goodfrag;
//   goodfrag.reserve(frames.size()*200); // 200 will be changed
// 
//   float costmin = 1000;
//   FragID minfrag(0, 0);
// 
//   //compute scores gunn score: it is like what I want
//   for (Size fnr = 1; fnr <=frames.size(); fnr++) {
//     ScoreList scores;
//     core::fragment::Frame const& frame(*(frames[fnr]));
//     cost_->score(frame, pose, scores);
//     for( Size j = 1; j <=frame.nr_frags(); ++j) {
//       core::Real s = scores[j];
//       if ( s < costmin ) {
//         costmin = s;
//         minfrag = FragID (fnr, j);
//       }
//       if ( s < cost_->cutoff() ) {
//         goodfrag.push_back( FragID (fnr, j));
//       }
//     }
//   }
//   
//   if( goodfrag.size() < 1 ) {
//     if (costmin > 12. ) return false;
//     frame_num = minfrag.first;
//     frag_num  = minfrag.second;
//   }
//   else {
//     FragID choice = goodfrag[ static_cast <int> (RG.uniform() * goodfrag.size()) + 1];
//     frame_num = choice.first;
//     frag_num  = choice.second;
//   }
//   return true;
// }
