// Copyright (C)  2012 Zhang Initative Research Unit
// batch_job.hh -description
// written by Rojan Shrestha 

#ifndef  BATCH_JOB_HEADER_HH
#define  BATCH_JOB_HEADER_HH

#include<iostream>
#include<disorder_remodel.hh>

using namespace std;

namespace batch_job {

  void dump_model_tfz(ofstream &output_stream, char* pose_id, const float tfz_score) { 
    output_stream<<pose_id;  
    output_stream.setf(ios::fixed, ios::floatfield);
    output_stream.precision(1);
    output_stream.width(6);
    output_stream<<tfz_score;
    output_stream<<endl;
  }

  void distribute_job(DisorderModel disorder_model, 
                      const float min_cutoff, const int succeed_jobs) {

    const size_t total_jobs  = disorder_model.get_num_of_models(); 
    size_t success_counter = 0;
    float tfz_score = 0;  
    char* c_pose_name = "";

    ofstream output_file;
    output_file.open("phaser_scores.out");

    for(size_t jobid = 1; jobid < total_jobs; jobid++) {
      disorder_model.remodel_disorder_rsds(jobid, tfz_score, c_pose_name);
      if(tfz_score >= min_cutoff) { 
        success_counter++;
        dump_model_tfz(output_file, c_pose_name, tfz_score);  
      }
      if(success_counter > succeed_jobs) break;
    }
    output_file.close();
  }

  void distribute_job(DisorderModel disorder_model) {
    const size_t total_jobs  = disorder_model.get_num_of_models(); 
    for(size_t jobid = 1; jobid < total_jobs; jobid++) {
      disorder_model.remodel_disorder_rsds(jobid);
    }
  }
}

#endif
