#include <init_rosetta.hh>

Rosetta::Rosetta() {
  init_ = 1; 
}

Rosetta::Rosetta(int init) {
  init_ = init; 
}

Rosetta::Rosetta(int argc, char* argv[]) {
  protocols::init(argc, argv); 
  fullatom_scorefxn_ = core::scoring::getScoreFunction(true);
  centroid_scorefxn_ = core::scoring::ScoreFunctionFactory::create_score_function("score3");
  // I will soon replace this code with very simple two lines of codes.
  try {
    string frag9_file; 
    string frag3_file;
    utility::vector1<int> frag_sizes(option[OptionKeys::loops::frag_sizes]);
    FileVectorOption frag_files(option[OptionKeys::loops::frag_files]);
    for(unsigned i=1; i<= frag_sizes.size(); i++) {
      if (frag_sizes[i] == 9) frag9_file = frag_files[i];
      else if(frag_sizes[i] == 3) frag3_file = frag_files[2];
    }
  
    // if ((frag9_file == std::string("none")) && (frag3_file == std::string("none"))) return false;
    core::fragment::FragmentIO fragIO;
    fragset_small_ = fragIO.read_data( frag3_file ); 
    fragset_large_ = fragIO.read_data( frag9_file ); 
  }
  catch(exception& e) {
    cout<< e.what()<<endl;
  }
  init_ = 1;
}


core::scoring::ScoreFunctionOP Rosetta::get_cen_score_fxn() {
  return centroid_scorefxn_;
}

core::scoring::ScoreFunctionOP Rosetta::get_fullatom_score_fxn() {
  return fullatom_scorefxn_;
}

core::fragment::FragSetOP Rosetta::get_three_residue_fragments() {
  return fragset_small_;
}

core::fragment::FragSetOP Rosetta::get_nine_residue_fragments() {
  return  fragset_large_;
}

int Rosetta::get_init() {
  return init_;
}
