#ifndef INIT_HEADER_HH
#define INIT_HEADER_HH

#include <string>
#include <iostream>


//rosetta headers
#include <protocols/init.hh>

#include <core/scoring/ScoreFunction.fwd.hh>
#include <core/scoring/ScoreType.hh>
#include <core/scoring/ScoreFunctionFactory.hh>

#include <protocols/abinitio/AbrelaxApplication.hh>
#include <protocols/abinitio/ClassicAbinitio.hh>
#include <core/types.hh>

#include <core/options/option.hh>
#include <core/options/keys/loops.OptionKeys.gen.hh>

#include <core/fragment/FragSet.hh>
#include <core/fragment/FragmentIO.hh>

#include <protocols/loops/loops_main.hh>

using namespace std;
using namespace core::options;
using namespace core::options::OptionKeys;


class Rosetta {
  private:
    int init_;
    core::fragment::FragSetOP fragset_small_;
    core::fragment::FragSetOP fragset_large_;
    core::scoring::ScoreFunctionOP fullatom_scorefxn_;
    core::scoring::ScoreFunctionOP centroid_scorefxn_;
  
  public:
    Rosetta(); //just for object status 

    Rosetta(int init); //just for object status 

    Rosetta(int argc, char* argv[]); 

    core::scoring::ScoreFunctionOP get_cen_score_fxn(); 

    core::scoring::ScoreFunctionOP get_fullatom_score_fxn(); 

    core::fragment::FragSetOP get_three_residue_fragments();

    core::fragment::FragSetOP get_nine_residue_fragments();

    int get_init();  
};

#endif //end of INIT_HEADER_HH
