#ifndef MR_HH_INCLUDE 
#define MR_HH_INCLUDE 

#include<map>
#include<string>
#include<iostream>
#include<exception>

#include <core/pose/Pose.hh>
#include <utility/pointer/ReferenceCount.hh>

#include<util.hh>

using namespace std;
typedef core::pose::Pose Pose;

class MolecularReplacement { 

  private:
    string phaser_command_;
    string space_group_;
    size_t num_of_copies_;
    size_t state_;
  
  private:

    bool call_phaser(string phaser_cmd, map<string, string> &phaser_score); 

    inline string replace_keyword(const string modelpath, const string modeltag) {
      string phaser_command = phaser_command_;
      const string model_name = "$MODEL";
      const string model_tag  = "$TAG";
      if(!phaser_command.empty()) {
         size_t found = phaser_command.find(model_name); 
         if (found != string::npos) {
           phaser_command.replace(phaser_command.find(model_name), model_name.length(), modelpath); 
         }
         found = phaser_command.find(model_tag); 
         if (found != string::npos) {
           phaser_command.replace(phaser_command.find(model_tag), model_tag.length(), modeltag); 
         }
      }
      return phaser_command;
    }

    

  public:
     
     MolecularReplacement(); 

     MolecularReplacement(string phaser_cmd_file); 

     MolecularReplacement(string phaser_cmd_file, string space_group, size_t num_of_copies); 

     void show(); 

     int get_state(); 

     float run_phaser(Pose pose, string tag); 

     float evaluate_phaser_score(map<string,string> &phaser_scores); 

};


#endif
