#ifndef STRUCT_UTIL_HEADER_HH
#define STRUCT_UTIL_HEADER_HH

//Rosetta header
#include<numeric/types.hh>
#include<numeric/xyzVector.hh>

#include <ObjexxFCL/FArray1D.hh>
#include <ObjexxFCL/FArray2D.hh>

#include <numeric/model_quality/rms.hh>
#include <core/scoring/rms_util.hh>
#include <core/scoring/rms_util.tmpl.hh>


#include <core/id/AtomID_Map.fwd.hh>
#include <utility/vector1_bool.hh>
#include <ObjexxFCL/FArray2D.fwd.hh>

//standard
#include <vector>

using namespace std;

namespace ModelUtility {

  typedef core::pose::Pose Pose;

  using namespace ObjexxFCL;
  using namespace core::scoring;
  using namespace numeric::model_quality;

  // float CA_rmsd(const Pose &pose1, const Pose &pose2); 

  float CA_rmsd(const Pose & pose1, const Pose & pose2, vector<float> &rsd_rmsds); 

  float CA_rmsd(const Pose & pose1,
                const Pose & pose2,
                const core::Size start,
                const core::Size end, 
                vector<float> &rsd_rmsds); 
  
  float rms_wrapper(int natoms,
                    FArray2D< numeric::Real > p1a,
                    FArray2D< numeric::Real > p2a, 
                    vector<float> &rsd_rmsds); 
  
  void calc_rms_fast(float & rms_out,
                     FArray2A< numeric::Real > xx,
                     FArray2A< numeric::Real > yy,
                     FArray1A< numeric::Real > ww,
                     int npoints,
                     numeric::Real ctx,
                     vector<float> &rsd_rmsds); 

};

#endif
