#include <util.hh>

string OutputFormat::get_output_format(const string prefix, 
                                        const char to_be_filled_char, 
                                        const unsigned int length, 
                                        const unsigned int current_id) {
  ostringstream output_format;
  output_format.width(length);
  output_format.fill(to_be_filled_char);
  output_format<<current_id;
  return prefix + output_format.str();
}


string OutputFormat::get_output_format(const string prefix, 
                                        const char to_be_filled_char, 
                                        const unsigned int length, 
                                        const string full_file_path, 
                                        const unsigned int current_id) { 
  ostringstream output_format;
  output_format.width(length);
  output_format.fill(to_be_filled_char);
  output_format<<current_id;

  const string file_name_wo_ext = get_file_name_wo_extension(full_file_path);
  return prefix + file_name_wo_ext + "_" + output_format.str();
}


string OutputFormat::get_file_name_wo_extension(const string full_file_path) {
  size_t found=full_file_path.find_last_of("/\\");
  string filename_w_ext = full_file_path.substr(found+1);
  found = filename_w_ext.find_last_not_of(".pdb");
  if(found != string::npos)
    return filename_w_ext.erase(found+1);
  else {
    filename_w_ext.clear();
    return "";
  }
}
