#ifndef UTIL_HEADER_HH
#define UTIL_HEADER_HH

#include<sstream>
#include<string>
#include<iostream>

using namespace std;

namespace TypeCast {

  template <class T> void string2numeric(T& t, const string s) { 
    std::istringstream iss(s);
    iss>>t;
  }
  
};


namespace StatisticalUtil {

  template<class T>
  bool pairCompare (const T &x, const T &y) {
    return x.second < y.second;
  }

  template<class T>
  typename T::const_iterator map_max_element(const T &input) {
    typedef typename T::value_type pair_type;
    return max_element(input.begin(), input.end(), pairCompare<typename T::value_type>);
  }

  template<class T>
  typename T::const_iterator map_min_element(const T &input) {
    typedef typename T::value_type pair_type;
    return min_element(input.begin(), input.end(), pairCompare<typename T::value_type>);
  }

};


namespace OutputFormat {
  
  string get_output_format(const string prefix, 
                           const char to_be_filled_char, 
                           const unsigned int length, 
                           const unsigned int current_id); 

  string get_output_format(const string prefix, 
                           const char to_be_filled_char, 
                           const unsigned int length, 
                           const string full_file_path,
                           const unsigned int current_id); 

  string get_file_name_wo_extension(const string full_file_path);

};


#endif
